(function() {
    function getRequest() {
        var url = document.currentScript.src;
        var request = new Object(null);
        var pos = url.indexOf("?");
        if (pos != -1) {
            var str = url.substr(pos + 1);
            var strs = str.split("&");
            for(var i = 0; i < strs.length; i ++) {
                var kv = strs[i].split("=");
                if (kv.length > 1) {
                    request[kv[0]] = decodeURIComponent(kv[1]);
                } else {
                    request[kv[0]] = kv[0];
                }
            }
        }
        return request;
    }

    function windowClose() {
        try {
            adtalos.dispatch('close', '');
        }
        catch(e) {
            window.close();
        }
    }

    function showAdText() {
        var bottom_bar = document.createElement("div");
        var ad_text = document.createElement("div");
        bottom_bar.style.position = "fixed";
        bottom_bar.style.bottom = 0;
        bottom_bar.style.right = 0;
        bottom_bar.style.display = "flex";
        bottom_bar.style.flexWrap = "nowrap";
        bottom_bar.style.alignItems = "center";
        bottom_bar.style.width = "auto";
        bottom_bar.style.height = "2vw";
        bottom_bar.style.padding = "1vw";
        bottom_bar.style.backgroundColor = "#3385FF";
        bottom_bar.style.borderTop = "#ffffff solid 1px";
        bottom_bar.style.borderLeft = "#ffffff solid 1px";
        bottom_bar.style.borderRadius = "1.5vw 0 0 0";
        bottom_bar.style.zIndex = "2147483647";
        ad_text.style.fontSize = "2vw";
        ad_text.style.color = "#eeeeee";
        ad_text.innerText = "广告";

        bottom_bar.appendChild(ad_text);
        document.body.appendChild(bottom_bar);
    }

    var request = getRequest();
    console.log(JSON.stringify(request));

    if (request["showadtext"] != "false") {
        showAdText();
    }

    var clickRange = document.createElement("div");
    clickRange.style.position = "fixed";
    clickRange.style.margin = "0";
    clickRange.style.zIndex = "2147483647";

    document.body.appendChild(clickRange);

    var button = document.createElement("div");
    button.style.position = "relative";
    button.style.display = "flex";
    button.style.justifyContent = "center";
    button.style.alignItems = "center";


    button.style.backgroundColor = "rgba(0,0,0,0.4)";
    button.style.lineHeight = "1.2em";
    button.style.color = "#FFFFFF";

    clickRange.appendChild(button);

    var close_button = document.createElementNS('http://www.w3.org/2000/svg','svg');
    close_button.setAttribute("viewBox", "0 0 20 20");
    var close_path = document.createElementNS('http://www.w3.org/2000/svg','path');
    close_path.setAttribute("d", "M2.93 17.07A10 10 0 1 1 17.07 2.93 10 10 0 0 1 2.93 17.07zm1.41-1.41A8 8 0 1 0 15.66 4.34 8 8 0 0 0 4.34 15.66zm9.9-8.49L11.41 10l2.83 2.83-1.41 1.41L10 11.41l-2.83 2.83-1.41-1.41L8.59 10 5.76 7.17l1.41-1.41L10 8.59l2.83-2.83 1.41 1.41z");
    close_button.appendChild(close_path);
    close_button.style.fill = "#ffffff";

    var delayed = request["delayed"];
    var showclose = request["showclose"] === "true";
    var showskip = request["showskip"] === "true";

    if (delayed && delayed != "0") {
        if (showclose) {
            button.style.display = "none";
        } else if (showskip) {
            clickRange.onclick = windowClose;
        }
        function countDown() {
            if (!showclose) {
                if (showskip) {
                    button.innerHTML = "跳过 " + delayed;
                } else {
                    button.innerHTML = delayed;
                }
            }
            setTimeout(function() {
                if (delayed-- > 1) {
                    countDown();
                } else if (showclose) {
                    button.style.opacity = 0;
                    button.style.display = "flex";
                    button.appendChild(close_button);
                    clickRange.onclick = windowClose;
                    var timer = setInterval(function() {
                        var opacity = parseFloat(button.style.opacity);
                        if (opacity >= 1) {
                            clearInterval(timer);
                        }
                        button.style.opacity = parseFloat(button.style.opacity) + 0.1;
                    }, 100);
                } else {
                    windowClose();
                }
            }, 1000);
        }
        countDown();
    } else {
        if (showclose) {
            button.appendChild(close_button);
            clickRange.onclick = windowClose;
        } else {
            button.style.display = "none";
        }
    }

    function resize() {
        var unit = "vw";
        if (request["delayed"] > 0) {
            var width = adtalos.getWidth();
            var height = adtalos.getHeight();
            unit = (width < height) ? "vw" : "vh";
        }

        var x = request["x"] + unit;
        if (x) {
           if (x.substr(0, 1) == "-") {
               clickRange.style.right = x.slice(1);
           } else {
               clickRange.style.left = x;
           }
        } else {
            clickRange.style.left = 0;
        }
        var y = request["y"] + unit;
        if (y) {
           if (y.substr(0, 1) == "-") {
               clickRange.style.bottom = y.slice(1);
           } else {
               clickRange.style.top = y;
           }
        } else {
            clickRange.style.top = 0;
        }
        clickRange.style.width = request["w2"] + unit;
        clickRange.style.height = request["h2"]  + unit;
        button.style.width = request["w1"] + unit;
        button.style.height = request["h1"] + unit;
        button.style.left = ((request["w2"] - request["w1"]) / 2) + unit;
        button.style.top = ((request["h2"] - request["h1"]) / 2) + unit;
        button.style.borderRadius = (request["h1"] / 2) + unit;
        button.style.fontSize = (request["h1"] / 2) + unit;
        close_button.style.width = (request["h1"]) + unit;
        close_button.style.height = (request["h1"]) + unit;
    }

    resize();

    if (request["delayed"] > 0) {
        window.addEventListener('resize', resize);
    }

    if (document.getElementsByTagName('video').length > 0) {
        var videoStart = false;
        var videoEnded = false;
        var video = document.getElementsByTagName('video')[0];

        var onloadedmetadata = function() {
            var data = {
                'currentTime': video.currentTime,
                'duration': video.duration,
                'videoWidth': video.videoWidth,
                'videoHeight': video.videoHeight,
                'muted': video.muted,
                'volume': video.volume,
                'autoplay': video.autoplay
            };
            adtalosVideoEventTrigger.callOnVideoLoad(JSON.stringify(data));
        }

        onloadedmetadata();

        video.addEventListener('loadedmetadata', onloadedmetadata);

        video.addEventListener('play', function() {
            if (videoStart) return;
            videoStart = true;
            adtalosVideoEventTrigger.callOnVideoStart();
        });
        video.addEventListener('playing', function() {
            adtalosVideoEventTrigger.callOnVideoPlay();
        });
        video.addEventListener('pause', function() {
            adtalosVideoEventTrigger.callOnVideoPause();
        });
        video.addEventListener('ended', function() {
            videoEnded = true;
            adtalosVideoEventTrigger.callOnVideoEnd();
        });
        video.addEventListener('volumechange', function() {
            adtalosVideoEventTrigger.callOnVideoVolumeChange(video.volume, video.muted);
        });
        video.addEventListener('timeupdate', function() {
            adtalosVideoEventTrigger.callOnVideoTimeUpdate(video.currentTime, video.duration);
        });
        video.addEventListener('error', function() {
            adtalosVideoEventTrigger.callOnVideoError();
        });
        window.addEventListener('unload', function() {
            if (!videoEnded) {
                adtalosVideoEventTrigger.callOnVideoBreak();
            }
        });
    }
})();